︠5beac236-47e6-44db-9b07-68050f30609as︠
# http://en.wikipedia.org/wiki/Fourier_series

import scipy
import pylab
# import sys

def calc_x_k_list(k, t_list):
	result_list = []
	w = 1
	T_0 = 4
	for t in t_list:
		t1 = 1.0 * w/T_0 * scipy.sinc(1.0 * w/ T_0 *k)
		t_last = scipy.e**complex(0, 2 * scipy.pi * k /T_0 *  t)
		result = (t1 * t_last).real
		result_list.append(result)
	return result_list

def calc_x_f_list(k, t_list):
	y_list_list = []
	for k in range(-k, k):
		y_list = calc_x_k_list(k, t_list)
		y_list_list.append(y_list)
	final_y_list = [ sum(a) for a in zip(*y_list_list)]
	return final_y_list

#
#
#
t_list = scipy.arange(-2*scipy.pi, 2*scipy.pi, 0.1)

k = 3
y_list = calc_x_f_list(k, t_list)
p3 = pylab.plot(t_list, y_list, label = 'k=%d' % k)

k = 5
y_list = calc_x_f_list(k, t_list)
p5 = pylab.plot(t_list, y_list, label = 'k=%d' % k)

k = 200
y_list = calc_x_f_list(k, t_list)
p200 = pylab.plot(t_list, y_list, label = 'k=%d' % k)

pylab.legend()

pylab.title(r'Fourier Series')
pylab.xlabel(r'Time $t$')
pylab.ylabel(r'$x(t)$')
pylab.grid(True)

# filename = sys.argv[0]
# pylab.savefig(filename +'.png')

pylab.show()
︡52ac8a6f-e046-48de-9ad9-db20764f025c︡{"stdout":"<matplotlib.legend.Legend object at 0x7f74dd760290>\n"}︡{"stdout":"<matplotlib.text.Text object at 0x7f74dd7a70d0>\n"}︡{"stdout":"<matplotlib.text.Text object at 0x7f74dd858590>\n"}︡{"stdout":"<matplotlib.text.Text object at 0x7f74dd8774d0>\n"}︡{"file":{"filename":"2d7ea3c2-906c-4b81-b1ca-e06d36841202.svg","show":true,"text":null,"uuid":"ec85cc4c-c29b-4b12-abb3-808f6e5741be"},"once":false}︡{"done":true}︡
︠a64f4507-4c03-4f2d-9924-29b97dce2810︠










